Index: /trunk/SophyaPI/PIext/Makefile
===================================================================
--- /trunk/SophyaPI/PIext/Makefile	(revision 3122)
+++ /trunk/SophyaPI/PIext/Makefile	(revision 3123)
@@ -912,5 +1114,9 @@
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)hisprof.h \
+  $(SOPHYAINCP)generalfit.h \
   $(SOPHYAINCP)datatable.h \
+  $(SOPHYAINCP)basedtable.h \
   $(SOPHYAINCP)swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
@@ -923,4 +1129,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)machdefs.h \
   nomimagadapter.h nomgadapter.h \
   $(SOPHYAINCP)ppersist.h \
@@ -930,4 +1137,5 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)pidrawer.h \
@@ -960,4 +1168,5 @@
   $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -969,4 +1178,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
@@ -974,11 +1184,14 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)fioarr.h \
   pimgadapter.h \
   $(SOPHYAINCP)objfitter.h \
+  $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)histos2.h \
-  $(SOPHYAINCP)hisprof.h
+  $(SOPHYAINCP)hisprof.h \
+  $(SOPHYAINCP)generalfit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  nomimagadapter.cc
  
@@ -987,4 +1200,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)machdefs.h \
   nomskymapadapter.h nomgadapter.h \
   $(SOPHYAINCP)ppersist.h \
@@ -994,4 +1208,5 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)pidrawer.h \
@@ -1024,4 +1239,5 @@
   $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -1033,4 +1249,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
@@ -1038,4 +1255,6 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
+  $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)spherepos.h \
@@ -1044,8 +1263,10 @@
   $(SOPHYAINCP)longlat.h \
   $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)skymap.h \
   $(SOPHYAINCP)spherethetaphi.h \
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
@@ -1057,4 +1278,5 @@
   $(SOPHYAINCP)fiosphereecp.h \
   pitvmaad.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)complexios.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  nomskymapadapter.cc
@@ -1065,9 +1287,11 @@
   nomspecrespadapter.h nomgadapter.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)pidrawer.h \
@@ -1100,4 +1324,5 @@
   $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -1109,4 +1334,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
@@ -1114,6 +1340,8 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
   $(SOPHYAINCP)specresp.h \
   $(SOPHYAINCP)specrespvector.h \
+  $(SOPHYAINCP)specresp.h \
   $(SOPHYAINCP)gaussfilt.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  nomspecrespadapter.cc
@@ -1123,4 +1351,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)machdefs.h \
   nomtarradapter.h nomgadapter.h \
   $(SOPHYAINCP)ppersist.h \
@@ -1130,4 +1359,5 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)pidrawer.h \
@@ -1160,4 +1390,5 @@
   $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -1169,12 +1400,20 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)utils.h \
   $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)fmath.h pitvmaad.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)tvector.h \
+  pitvmaad.h \
+  $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)piyfxdrw.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)fioarr.h nobjmgr.h \
-  dlftypes.h
+  $(SOPHYAINCP)dvlist.h dlftypes.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  nomtarradapter.cc
  
@@ -1183,4 +1422,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
@@ -1205,4 +1445,5 @@
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)peida.h \
@@ -1216,5 +1457,8 @@
   $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)generalfunc.h \
   nomtmatvecadapter.h nomgadapter.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pibwdggen.h \
@@ -1240,6 +1484,14 @@
   $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)ntupintf.h \
+  $(SOPHYAINCP)generalfit.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)generaldata.h \
   $(SOPHYAINCP)piyfxdrw.h \
-  pitvmaad.h nobjmgr.h dlftypes.h
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)pidrawer.h \
+  pitvmaad.h $(SOPHYAINCP)fioarr.h \
+  nobjmgr.h $(SOPHYAINCP)dvlist.h \
+  dlftypes.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  nomtmatvecadapter.cc
  
@@ -1274,6 +1526,8 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)hisprof.h \
   $(SOPHYAINCP)histerr.h \
+  $(SOPHYAINCP)hist2err.h \
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
@@ -1281,10 +1535,18 @@
   $(SOPHYAINCP)basedtable.h \
   $(SOPHYAINCP)segdatablock.h \
-  pawexecut.h piacmd.h \
+  pawexecut.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  piacmd.h \
   $(SOPHYAINCP)commander.h \
   $(SOPHYAINCP)pdlmgr.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)zthread.h \
-  dlftypes.h nobjmgr.h servnobjm.h nomgadapter.h \
+  dlftypes.h nobjmgr.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h \
+  servnobjm.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  nomgadapter.h \
   $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pibwdggen.h \
@@ -1310,8 +1572,11 @@
   $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)generalfit.h \
   $(SOPHYAINCP)generaldata.h \
   $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)generalfunc.h \
   pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)piapplx.h \
   $(SOPHYAINCP)piapplgen.h \
@@ -1329,12 +1594,18 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pipixmapx.h \
   $(SOPHYAINCP)pipixmapgen.h \
@@ -1346,7 +1617,9 @@
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
-  pihisto.h
+  pihisto.h $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pawexecut.cc
  
@@ -1356,4 +1629,5 @@
   $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)ppersist.h \
@@ -1386,4 +1660,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -1415,10 +1690,14 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
   $(SOPHYAINCP)parradapter.h \
@@ -1434,5 +1713,9 @@
   $(SOPHYAINCP)pi3ddrw.h \
   $(SOPHYAINCP)pigraph3d.h \
-  nobjmgr.h dlftypes.h piacmd.h \
+  nobjmgr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h dlftypes.h \
+  piacmd.h \
   $(SOPHYAINCP)commander.h \
   $(SOPHYAINCP)pdlmgr.h \
@@ -1442,7 +1725,9 @@
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
-  $(SOPHYAINCP)piscdrawwdg.h
+  $(SOPHYAINCP)piscdrawwdg.h \
+  $(SOPHYAINCP)ntupintf.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pi2dvec.cc
  
@@ -1451,4 +1736,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pdlmgr.h \
   $(SOPHYAINCP)dvlist.h \
@@ -1465,5 +1751,6 @@
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)zthread.h \
-  dlftypes.h \
+  dlftypes.h $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)strutil.h \
   $(SOPHYAINCP)strutilxx.h \
@@ -1474,4 +1761,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -1503,10 +1791,14 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
   $(SOPHYAINCP)parradapter.h \
@@ -1522,11 +1814,17 @@
   $(SOPHYAINCP)pi3ddrw.h \
   $(SOPHYAINCP)pigraph3d.h \
-  nobjmgr.h pisiadw.h \
+  nobjmgr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h pisiadw.h \
   $(SOPHYAINCP)pilistx.h \
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
   basexecut.h graphexecut.h piafitting.h nomgadapter.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)generalfit.h \
@@ -1540,10 +1838,13 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)utils.h \
   $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)fmath.h pawexecut.h \
-  cxxexecutor.h cxxexecwin.h contmodex.h flowmodex.h
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
+  $(SOPHYAINCP)tvector.h \
+  pawexecut.h cxxexecutor.h cxxexecwin.h contmodex.h flowmodex.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  piacmd.cc
  
@@ -1580,5 +1881,7 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
   $(SOPHYAINCP)fct1dfit.h \
+  $(SOPHYAINCP)generalfit.h \
   $(SOPHYAINCP)fct2dfit.h \
   $(SOPHYAINCP)ntuple.h \
@@ -1587,7 +1890,17 @@
   $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)hisprof.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)objfitter.h \
-  piafitting.h nomgadapter.h \
+  $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)hisprof.h \
+  piafitting.h \
+  $(SOPHYAINCP)machdefs.h \
+  nomgadapter.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pibwdggen.h \
@@ -1613,10 +1926,14 @@
   $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)pdlmgr.h dlftypes.h \
   piacmd.h \
   $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)zthread.h nobjmgr.h \
+  $(SOPHYAINCP)dvlist.h \
   pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)piapplx.h \
   $(SOPHYAINCP)piapplgen.h \
@@ -1634,12 +1951,18 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pipixmapx.h \
   $(SOPHYAINCP)pipixmapgen.h \
@@ -1651,4 +1974,5 @@
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
@@ -1658,5 +1982,6 @@
   $(SOPHYAINCP)basedtable.h \
   $(SOPHYAINCP)segdatablock.h \
-  nomgfdadapter.h nomimagadapter.h nomtmatvecadapter.h
+  nomgfdadapter.h nomimagadapter.h nomtmatvecadapter.h \
+  $(SOPHYAINCP)generaldata.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  piafitting.cc
  
@@ -1774,4 +2099,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -1803,4 +2129,6 @@
   $(SOPHYAINCP)sopnamsp.h \
   pihisto2d.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenubarx.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
@@ -1836,4 +2164,5 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pieldrw.h \
   $(SOPHYAINCP)srandgen.h
@@ -1888,5 +2217,6 @@
   $(SOPHYAINCP)pigratt.h \
   $(SOPHYAINCP)piaxes.h \
-  $(SOPHYAINCP)hisprof.h
+  $(SOPHYAINCP)hisprof.h \
+  $(SOPHYAINCP)histos.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pihisto.cc
  
@@ -1897,4 +2227,5 @@
   $(SOPHYAINCP)skymapinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
@@ -1904,4 +2235,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -1933,10 +2265,14 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
   $(SOPHYAINCP)parradapter.h \
@@ -1960,6 +2296,8 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -1967,4 +2305,5 @@
   $(SOPHYAINCP)commander.h \
   $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)zthread.h pisiadw.h \
@@ -1972,7 +2311,12 @@
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
-  servnobjm.h nomhistadapter.h nomgadapter.h \
+  servnobjm.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  nomhistadapter.h nomgadapter.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)generalfit.h \
@@ -1986,4 +2330,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
@@ -1991,6 +2336,8 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
   $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)hisprof.h \
   $(SOPHYAINCP)histerr.h \
@@ -2002,6 +2349,11 @@
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)fioarr.h \
-  nomtmatvecadapter.h nomtarradapter.h \
+  nomtmatvecadapter.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)generaldata.h \
+  nomtarradapter.h \
+  $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)datatable.h \
+  $(SOPHYAINCP)basedtable.h \
   $(SOPHYAINCP)swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
@@ -2019,4 +2371,5 @@
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
@@ -2026,5 +2379,7 @@
   $(SOPHYAINCP)specresp.h \
   $(SOPHYAINCP)gaussfilt.h \
-  nomspecrespadapter.h piaversion.h
+  nomspecrespadapter.h \
+  $(SOPHYAINCP)specresp.h \
+  piaversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  piinit.cc
  
@@ -2095,4 +2450,5 @@
   $(SOPHYAINCP)pibwdggen.h \
   $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)piwdgx.h \
   $(SOPHYAINCP)piwdggen.h \
@@ -2143,5 +2499,6 @@
   $(SOPHYAINCP)generaldata.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)poly.h
+  $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)generalfunc.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pipodrw.cc
  
@@ -2151,4 +2508,5 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)nbmath.h \
@@ -2159,4 +2517,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -2188,10 +2547,14 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
   $(SOPHYAINCP)parradapter.h \
@@ -2214,6 +2577,8 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -2221,11 +2586,15 @@
   $(SOPHYAINCP)commander.h \
   $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)zthread.h pisiadw.h \
   $(SOPHYAINCP)pilistx.h \
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
-  servnobjm.h
+  servnobjm.h \
+  $(SOPHYAINCP)pdlmgr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pisiadw.cc
  
@@ -2237,4 +2606,5 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)psighand.h \
@@ -2264,4 +2634,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -2293,10 +2664,14 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
   $(SOPHYAINCP)parradapter.h \
@@ -2312,15 +2687,25 @@
   $(SOPHYAINCP)pi3ddrw.h \
   $(SOPHYAINCP)pigraph3d.h \
-  nobjmgr.h dlftypes.h piacmd.h \
+  nobjmgr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h dlftypes.h \
+  piacmd.h \
   $(SOPHYAINCP)commander.h \
   $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)zthread.h pisiadw.h \
   $(SOPHYAINCP)pilistx.h \
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
   servnobjm.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)psfile.h \
   $(SOPHYAINCP)piimgtools.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)piapplx.h \
   $(SOPHYAINCP)pidrwtools.h \
   $(SOPHYAINCP)piaxestools.h \
@@ -2341,4 +2726,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)lut.h \
   $(SOPHYAINCP)tmatrix.h \
@@ -2360,4 +2746,5 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tvector_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pitvmaad.cc
@@ -2368,12 +2755,15 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -2411,4 +2801,5 @@
   $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
@@ -2416,4 +2807,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)ntupintf.h \
   $(SOPHYAINCP)poly.h \
   $(SOPHYAINCP)peida.h \
@@ -2421,5 +2813,7 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)generalfunc.h \
   pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)piapplx.h \
   $(SOPHYAINCP)piapplgen.h \
@@ -2437,12 +2831,18 @@
   $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pioptmenux.h \
   $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pistdwdgx.h \
   $(SOPHYAINCP)pifilechox.h \
   $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piwindowx.h \
   $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
   $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
   $(SOPHYAINCP)pipixmapx.h \
   $(SOPHYAINCP)pipixmapgen.h \
@@ -2453,12 +2853,17 @@
   piacmd.h \
   $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
   $(SOPHYAINCP)ctimer.h pisiadw.h \
   $(SOPHYAINCP)pilistx.h \
   $(SOPHYAINCP)pilistgen.h \
   $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)piperiodx.h \
   $(SOPHYAINCP)pitherm.h \
   $(SOPHYAINCP)resusage.h \
   $(SOPHYAINCP)fct1dfit.h \
+  $(SOPHYAINCP)generalfit.h \
   $(SOPHYAINCP)fct2dfit.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)matharr.h \
   pitvmaad.h $(SOPHYAINCP)ntuple.h \
@@ -2467,4 +2872,5 @@
   $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)hisprof.h \
   $(SOPHYAINCP)datatable.h \
@@ -2473,5 +2879,6 @@
   $(SOPHYAINCP)piyfxdrw.h \
   $(SOPHYAINCP)pisurfdr.h \
-  pintuple.h pintup3d.h pipodrw.h
+  pintuple.h pintup3d.h \
+  $(SOPHYAINCP)pi3ddrw.h pipodrw.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  servnobjm.cc
  
Index: /trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/basexecut.cc	(revision 3122)
+++ /trunk/SophyaPI/PIext/basexecut.cc	(revision 3123)
@@ -1146,6 +1146,8 @@
 usage += "\n  (_nl is the table line number or the sequential index)";
 usage += "\n- NTuple: ntuple variable names,_nl";
-usage += "\n- Histo1D/HProf/HistoErr: i,x,val,err,nb,_nl";
+usage += "\n- Histo1D/HProf: i,x,val,err,nb,_nl";
 usage += "\n- Histo2D: i,j,x,y,val,err,_nl";
+usage += "\n- HistoErr: i,x,val,err2,nb,_nl";
+usage += "\n- Histo2DErr: i,j,x,y,val,err2,nb,_nl";
 usage += "\n- Vector/Matrix: n,r,c,val,real,imag,mod,phas,_nl";
 usage += "\n- TArray: n,x,y,z,t,u,val,real,imag,mod,phas,_nl";
